alias isupport { return %isupport. [ $+ [ $1 ] $+ ] . [ $+ [ $prop ] ] }

alias ismod {
  if ($1 isincs $gettok($gettok($isupport($cid).PREFIX,1,40),1,41)) { return $true }
  return $false
}

alias isvar {
  if ($1 isincs $gettok($isupport($cid).CHANMODES,1,44)) { return $true }
  if ($ismod($1)) { return $true }
  return $false
}

on *:START: {
  unset %isupport.*
}

raw 001:*: { unset %isupport. [ $+ [ $cid ] $+ ] .* }
on *:DISCONNECT: { unset %isupport. [ $+ [ $cid ] $+ ] .* }

raw 005:*: {
  var %x = $gettok($2-,0,32), %y = 1
  while (%y <= %x) {
    var %z = $gettok($2-,%y,32)
    if (%z != $null) {
      var %a = $gettok(%z,1,61)
      if (%a != $null) {
        var %b = $gettok(%z,2-,61)
        set %isupport. [ $+ [ $cid ] $+ ] . [ $+ [ %a ] ] $iif(%b != $null,%b,$true)
      }
    }
    inc %y
  }
}

on ^*:SNOTICE:*: {
  prints notice $enclose($nick).not $1-
  haltdef
}
on ^*:USERMODE: {
  prints mode * $nick $enclose($nuhost($fulladdress)).brk sets mode: $1-
  haltdef 
}

;    1  2      3    4    5      6    7      8  9-
;352 me target user host server nick status :0 name
#rename on
raw 352:*: {
  if (($network == BitlBee) && ($6 != root) && ($6 != A-twitter) && ($6 != $me)) {
    var %p = X, %n = $3
    if ($4 == chat.facebook.com) {
      var %p = F
      var %n = $iif($gettok($9-,0,32) > 1,$+($gettok($9-,1,32),$gettok($9-,-1,32)),$9)
    }
    elseif (($4 == public.talk.google.com) || ($4 == gmail.com) || ($left($6,1) == J)) {
      var %p = G
      var %n = $iif($gettok($9-,0,32) > 1,$+($gettok($9-,1,32),$gettok($9-,-1,32)),$9)
    }
    elseif ($4 == twitter) {
      var %p = T
      var %n = $iif($gettok($9-,0,32) > 1,$+($gettok($9-,1,32),$gettok($9-,-1,32)),$9)
    }
    elseif ([?][*] iswm $6) {
      var %p = $mid($6,2,1)
      var %n = $left($right($6,-4),-1)
    }
    elseif (?-* iswm $6) {
      var %p = $left($6,1)
      var %n = $right($6,-2)
    }
    elseif ($4 == login.icq.com) { var %p = I }
    var %g = $lower($remove(%n,',-,.,_))
    if (%g isalnum) {
      var %f = $+(%p,-,$left(%g,$calc($isupport($cid).nicklen - 2)))
      if ($6 != %f) {
        set %bitlbee.lastnick. [ $+ [ %f ] ] $6
        .timer 1 1 .msg &bitlbee rename $6 %f
      } 
    }
  }
}
#rename end
alias dowho {
  if (($me ison $1) && ($nick($1,0) < 100)) { who $1 }
}
;-Channels-;
on ^*:JOIN:#: { 
  if ($nick == $me) { .timer 1 5 dowho $chan }
  elseif ($network == BitlBee) { .timer 1 1 who $nick }
  ;if ($network != BitlBee) {
  printc join $chan * $nick $enclose($nuhost($fulladdress)).brk joined
  ;}
  haltdef
}
on ^*:PART:#: {
  ;if ($network != BitlBee) {
  printc part $chan * $nick $enclose($nuhost($fulladdress)).brk left $iif($1- != $null,$enclose($cf($1-)).brk)
  ;}
  haltdef
}
on ^*:KICK:#: { 
  var %a = $address($knick,5)
  printc kick $chan * $knick $iif(%a != $null,$enclose($nuhost(%a)).brk) was kicked by $nick $enclose($nuhost($fulladdress)).brk $iif($1- != $null,$enclose($cf($1-)).brk)
  haltdef
}
on ^*:RAWMODE:#: {
  if ($network != BitlBee) {
    printc mode $chan * $nick $enclose($nuhost($fulladdress)).brk sets mode: $1-
  }
  haltdef 
}
on ^*:SERVERMODE:#: {
  if ($network != BitlBee) {
    printc mode $chan * $nick sets mode: $1-
  }
  haltdef 
}
on ^*:QUIT: { 
  ;if ($network != BitlBee) {
  printu quit $nick * $nick $enclose($nuhost($fulladdress)).brk quit $iif($1- != $null,$enclose($cf($1-)).brk)
  ;}
  haltdef
}
on ^*:NICK: { 
  if ($network == BitlBee) {
    var %c = %bitlbee.lastnick. [ $+ [ $newnick ] ]
    if (%c != $null) { unset %bitlbee.lastnick. [ $+ [ $newnick ] ] }
  }
  printu nick $newnick * $nick $enclose($nuhost($fulladdress)).brk is now $newnick
  haltdef
}

on ^*:TEXT:*:#: {
  if ($network == BitlBee) {
    if ($nick == root) {
      if ($1 != $null) {
        if (($1 != Nick) || ($2 != successfully) || ($3 != changed)) {
          ;Nick successfully changed
          var %m = $1, %n = $2-, %o = info
          if ($gettok(%m,0,40) > 1) { var %m = $gettok(%m,1,40) $+($chr(40),$gettok(%m,2-,40)) }
          var %p = $gettok(%m,1,32)
          if (($2 == -) && ((%p == MSN) || (%p == YAHOO) || (%p == JABBER) || (%p == OSCAR) || (%p == TWITTER) || (%p == GTALK) || (%p == FB))) {
            var %m = $+([,$upper($gettok(%m,1,32)),]) $gettok(%m,2-,32)
            var %n = $3- 
            var %o = info2
          }
          else { var %m = $+($upper($left(%m,1)),$right(%m,-1)) }
          printc %o $chan * %m %n
        }
        if (($1 == Nick) && ($3 == already) && ($4 == exists)) {
          ;1    2          3       4
          ;Nick `M-stefan' already exists
          var %b = $left($right($strip($2),-1),-1)
          var %c = %bitlbee.lastnick. [ $+ [ %b ] ]
          if (%c != $null) {
            var %d = $gettok(%b,0,95)
            var %e = $+(%b,_2)
            if (%d > 1) { var %e = $+($gettok(%b,1,95),_,$calc($gettok(%b,2,95) + 1)) }
            unset %bitlbee.lastnick. [ $+ [ %b ] ]
            set %bitlbee.lastnick. [ $+ [ %e ] ] %c
            .timer 1 1 .msg $chan rename %c %e
          }
        }
        elseif (($1 == Oscar) && ($3 == New) && ($4 == Request:)) {
          ;1     2 3   4        5   6    7         8     9  10  11  12 13    14    15   16  17  18        19      20
          ;oscar - New request: The user 551821557 wants to add you to their buddy list for the following reason:
          ;Привети
          ;При
          ;Хочешь узнать с кем тебе изменяют
          if (($left($20,1) == ) || (($20 == No) && ($21 == reason))) {
            .msg $chan no
            .msg $chan block $1 $7
          }
        }
        elseif (($3 == Error:) && ($4 == Account) && ($10 == different) && ($11 == location)) {
          .timer 1 3 .msg $chan account on
        }
      }
      haltdef
    }
    elseif ($nick == A-twitter) {
      if ($left($1,$len($me)) == $me) { printm normal $chan $+(<T-,$lower($left($right($strip($2),-1),-1)),>) $3- }
      else { printc info2 $chan * $1- }
      haltdef
    }
  }
  elseif (($network == freenode) && ($left($nick,4) == CIA-) && ($chan == #cube2)) {
    scon -a cia_msg #sauerbraten $1-
  }
}

alias cia_msg {
  if ($me ison $1) {
    var %x = $nick($1,0), %y = 1, %z = 0
    while (%x >= %y) {
      var %c = $nick($1,%y)
      if ($left(%c,4) == CIA-) { var %z = 1 | var %y = %x }
      inc %y
    }
    if (%z == 0) { msg $1 $2- }
  }
}

alias botcmd_2_isupport {
  if ($3 ischan) {
    if ($4 != $null) {
      var %x = %isupport. [ $+ [ $cid ] $+ ] . [ $+ [ $upper($4) ] ]
      bot_rmsg $3 $1 $+($upper($4),=,%x)
    }
  }
  else { bot_rmsg $3 $1 We're not on a channel! }
}
