on *:START: {
  ; never rely on a global variable..
  ; unsetall
  .notify $mnick
}

alias bitaway {
  away Away
  .timer 1 1 .msg &bitlbee set status Away
}

on *:CONNECT: {
  if ($network == BitlBee) { .timer 1 10 bitaway }
  elseif (%away.time != $null) { away %away.msg }
  if ($me != $mnick) { tnick $mnick }
}

alias nickregain {
  if ($1 == IDENTIFY) { tnick $mnick }
  var %a = 1, %b = $ini(perform.ini,perform,0)
  while (%a <= %b) {
    var %c = $ini(perform.ini,perform,%a)
    var %d = $readini(perform.ini,perform,%c)
    var %e = $gettok(%d,1,44)
    if (%e == $network) {
      var %f = $gettok(%d,2,44)
      if ($1 == GHOST) {
        if (IDENTIFY isincs %f) {
          prints notify * Attempting to remove $mnick using services
          $replace(%f,IDENTIFY,$iif($mnick isin %f,GHOST,GHOST $mnick))
          return
        }
      }
      elseif ($1 == IDENTIFY) {
        if ((IDENTIFY isincs %f) && ($mnick !isincs %f)) {
          prints notify * Attempting to identify as $mnick using services
          %f
          return
        }
      }
    }
    inc %a
  }
}
#nickregain on
on *:NOTIFY: {
  if (($nick == $mnick) && ($me != $nick)) { nickregain ghost }
}
on *:UNOTIFY: {
  if (($nick == $mnick) && ($me != $nick)) {
    prints notify * Main nickname $mnick has gone offline, changing nicknames
    nickregain identify
  }
}
raw 433:*: { 
  if ($2 == $mnick) {
    prints notify * Main nickname $mnick is taken, will try to regain
    ;notify $mnick
  }
  else {
    prints notify * Nickname $2 is taken, trying to another
  }
  tnick $+($2,_)
  haltdef
}
#nickregain end

alias aquit {
  ;var %x = $chan(0), %y = 1
  ;while (%y <= %x) {
  ;  var %c = $chan(%y)
  ;  if (($botallow(%c) > 3) && ($me isop %c)) { bmode %c -l }
  ;  inc %y
  ;}
  .timer 1 1 quit $1-
}
alias x { scon -a aquit $1- | .timer 1 10 exit }

alias unaway { away $iif($network == BitlBee,Away) }

alias a {
  if ($1 != $null) {
    set %away.time $ctime
    set %away.msg $1-
    scon -a away %away.msg
  }
  elseif ((%away.time != $null) || ($away == $true)) {
    unset %away.*
    scon -a unaway
  }
}

alias n { return $1- }
alias paway {
  if ((%away.time != $null) || ($away == $true)) {
    msg $1 $+($2,:) Sorry, but I am currently away, %away.msg $enclose($dur($calc($ctime - %away.time))).brk
  }
}

alias bool {
  if (($1 == ON) || ($1 == TRUE) || ($1 == 1)) { return 1 }
  else { return 0 }
}

alias incini {
  if ($readini($1,$2,$3) isnum) { writeini -n $1 $2 $3 $calc($readini($1,$2,$3) + 1) }
  else { writeini -n $1 $2 $3 $readini($1,$2,$3) 1 }
}

alias decini {
  if ($readini($1,$2,$3) isnum) { writeini -n $1 $2 $3 $calc($readini($1,$2,$3) - 1) }
  else { writeini -n $1 $2 $3 $readini($1,$2,$3) -1 }
}

alias nnick {
  if ($1 != $null) { return $gettok($1,1,33) }
  return $null
  :error
}

alias nuser {
  if ($1 != $null) { return $gettok($gettok($1,2,33),1,64) }
  return $null
  :error
}

alias nhost {
  if ($1 != $null) { return $gettok($1,2,64) }
  return $null
  :error
}

alias nuhost {
  if ($1 != $null) { return $gettok($1,2,33) }
  return $null
  :error
}

alias faddr { return $iif((@ isin $1) && (! isin $1),$1,$address($1,5)) }
alias fmask {
  var %q = $iif((@ isin $1) && (! isin $1),$1,$address($1,5))
  var %r = $iif($2 != $null,$2,5)
  var %n = 2
  if (%r != 5) {
    var %n = $nnick(%q)
    if (%n == $null) { var %n = * }
    var %u = $nuser(%q)
    if (%u == $null) { var %u = * }
    var %h = $nhost(%q)
    if (%h == $null) { var %h = * }
    elseif (gateway/web/freenode/ip.* iswm %h) {
      var %u = *
      var %h = $gettok(%h,2-,46)
      var %n = 3
    }
    var %g = $gettok(%h,0,46)
    var %w = 0, %x = 1, %y = 0
    while (%x <= %g) {
      var %z = $gettok(%h,%x,46)
      if (%z isnum) { inc %y }
      elseif ($gettok(%z,1,45) isnum) { var %w = %x }
      else { var %x = %g }
      inc %x
    }
    if ((%g == 4) && (%y == 4)) { var %h = $+($gettok(%h,$+(1-,%n),46),.*) }
    elseif (%w > 0) { var %h = $+(*.,$gettok(%h,$+($calc(%w + 1),-),46)) }
    return $mask($+(%n,!,%u,@,%h),%r)
  }
  return $mask(%q,%r)
}

alias fban { return $fmask($faddr($1),3) }

alias naddress {
  return $fmask($faddr($1),$2)
}
alias nfulladdress {
  return $faddr($1)
}

alias botcmd_2_mask { bot_rmsg $3 $1 $4 = $naddress($4,$iif($4 != $null,$4,3)) }
alias botcmd_2_host { bot_rmsg $3 $1 $4 = $naddress($4) }
alias botcmd_2_unobfuscate { botcmd_2_host $1- }

on *:START: { unset %dns }
on *:DNS: {
  if (%dns != $null) {
    var %n = $dns(0)
    if (%n > 0) {
      var %m = 1
      while (%m <= %n) {
        %dns $dns(%m).addr = $dns(%m).ip
        inc %m
      }
    }
    else { %dns domain name resolution failed }
    unset %dns
  }
}
alias botcmd_2_dns {
  if ($4 != $null) {
    if (%dns == $null) {
      bot_rmsg $3 $1 Please wait, resolving: $4
      set %dns bot_rmsg $3 $1
      dns $4 
    }
    else {
      bot_rmsg $3 $1 Already resolving another address.
    }
  }
  else {
    bot_rmsg $3 $1 No address specified.
  }
}
alias botcmd_2_longip {
  var %p = $longip($4)
  bot_rmsg $3 $1 $4 = %p
  if ((%dns == $null) && (. isin %p)) {
    set %dns bot_rmsg $3 $1 %p =
    dns %p
  }
}
alias botcmd_2_hexip {
  var %p = $longip($base($4,16,10))
  bot_rmsg $3 $1 $4 = %p
  if (%dns == $null) {
    set %dns bot_rmsg $3 $1 %p =
    dns %p
  }
}
alias botcmd_2_iphex { bot_rmsg $3 $1 $4 = $lower($base($longip($4),10,16)) }
alias botcmd_2_decrypt { botcmd_2_dns $1 $2 $3 $longip($base($4,16,10)) }

alias brk { return $+($3,$iif($1 isnum,$chr($1),$1),$3,$4-,$3,$iif($1 isnum,$chr($2),$2),$3) }

alias enclose { 
  if ($1 != $null) {
    if ($prop == brk) {
      var %qo = (
      var %qc = )
    }
    elseif ($prop == not) {
      var %qo = -
      var %qc = -
    }
    elseif ($prop == msg) {
      var %qo = <
      var %qc = >
    }
    else {
      var %qo = "
      var %qc = "
    }
    return $+($iif($left($1-,1) != %qo,%qo),$1-,$iif($right($1-,1) != %qc,%qc)) 
  }
  else { return $null }
}

alias tab {
  var %tablist
  var %wpm = 1
  while ( $ [ $+ [ %wpm ] ] != $null ) {
    var %tablist = $instok(%tablist, $ [ $+ [ %wpm ] ] ,0,9)
    inc %wpm
  }
  return $iif(%tablist,%tablist,$chr(9))
}

alias ar { return $ [ $+ [ $1 ] $+ ] ( [ $+ [ $2 ] $+ ] ) }
alias cf { return $+($1-,) }
alias cl { return $left($right($1-,$calc($len($1-) - 1)),$calc($len($1-) - 2)) }

alias prints { echo -tsc $1 $2- }
alias printa { echo -tac $1 $2- }
alias printc { if ($chan($2)) { echo -tc $1 $2 $3- } }
alias printq { if ($query($2)) { echo -tc $1 $2 $3- } }
alias printm { if ($chan($2)) { echo -tcmbfl $1 $2 $3- } }
alias printu {
  var %x = $comchan($2,0), %y = 1
  while (%y <= %x) {
    var %z = $comchan($2,%y)
    printc $1 %z $3-
    inc %y
  }
  if ($2 == $me) { prints $1 $3- }
  if ($query($2)) { printq $1 $2 $3- }
}
alias printn {
  prints $1 $2-
  var %z = $iif($2 == *,$3-,$2-)
  var %a = Notice, %b = %z
  if ($gettok(%z,0,58) > 1) { var %a = $gettok(%z,1,58) | var %b = $gettok(%z,2-,58) }
  ;agent speak $+(%a,.) %b
}

alias printb {
  prints $1 $2-
  var %z = $iif($2 == *,$3-,$2-)
  var %a = Notice, %b = %z
  if ($gettok(%z,0,58) > 1) { var %a = $gettok(%z,1,58) | var %b = $gettok(%z,2-,58) }
}

alias notneg {
  if ($2 != $null) {
    if ($1 > $2) { return $2 }
    elseif ($1 < 0) { return 0 }
    else { return $1 }
  }
  else {
    if ($1 < 0) { return 0 }
    else { return $1 }
  }
}

alias xmltag {
  var %a = $read($1,nw,$+(*<,$2,>*</,$2,>*))
  if (%a != $null) { return $gettok($gettok(%a,2-,62),1,60) }
  return $null
}

alias pfl {
  var %a = 1, %b = $ini(perform.ini,perform,0)
  while (%a <= %b) {
    var %c = $ini(perform.ini,perform,%a)
    var %d = $readini(perform.ini,perform,%c)
    var %e = $gettok(%d,1,44)
    var %f = $gettok(%d,2,44)
    if ((IDENTIFY isincs %f) || (AUTH isincs %f)) {
      prints info $+(%e,:) %f
    }
    else {
      prints normal $+(%e,:) %f
    }
    inc %a
  }
}

alias plural { return $+($1,',$iif(($right($1,1) != s) && ($right($1,1) != z),s)) }

alias rnd {
  var %x = 1, %y = 65535
  if ($1 != $null) {
    if ($2 != $null) { var %x = $1 | var %y = $2 }
    else { var %x = 1 | var %y = $1 }
  }
  var %a = $calc($ctime - $uptime(system,3) + $rand(%x,%y))
  return $calc((%a % (%y - (%x - 1))) + %x)
}

alias shorten {
  return $iif($len($2-) > $1,$left($2-,$1) [..],$2-)
}

alias b { return $+(,$1-,) }
alias br { return $+($chr(40),$1-,$chr(41)) }
alias bx {
  var %a = $0
  var %b = 1
  var %c = $null
  while (%a >= %b) { var %d = $+($chr(36),%b) | var %c = $iif(%c,$+(%c,$eval(%d,2)),$eval(%d,2)) | inc %b }
  return $+($chr(40),%c,$chr(41))
}
alias by {
  var %a = $0
  var %b = 1
  var %c = $null
  while (%a >= %b) { var %d = $+($chr(36),%b) | var %c = $iif(%c,$+(%c,[,$chr(32),],$eval(%d,2)),$eval(%d,2)) | inc %b }
  return %c
}
alias bw { return $iif(* isin $1-,$1-,$+($1-,$chr(32),*)) }
alias br { return $iif((* isin $1-) || (+ isin $1-),$bx($1-),$+($bx($1-),$chr(32),$bx(.*))) }
alias bg {
  var %a = $0
  var %b = 1
  var %c = $null
  while (%a >= %b) { var %d = $+($chr(36),%b) | var %c = $iif(%c,$+(%c,[,$chr(32),],$eval(%d,2)),$eval(%d,2)) | inc %b }
  return $+(^,%c,$chr(36))
}
alias max { return $iif($1 < $2,$2,$1) }
alias min { return $iif($1 > $2,$2,$1) }

alias smsg_ext { if ($me ison $2) { msg $2 $3- } }
alias smsg {
  var %a = $scon(0), %b = 1
  while (%b <= %a) {
    if ($scon(%b).network == $1) { scid $scon(%b) smsg_ext $1- }
    inc %b
  }
}
